DEFINE doctores DYNAMIC ARRAY OF RECORD
    DATE DATE,
    doctor STRING
END RECORD

DEFINE arr DYNAMIC ARRAY OF RECORD
    patient VARCHAR(30),
    col1 VARCHAR(10),
    col2 VARCHAR(10),
    col3 VARCHAR(10)
END RECORD

DEFINE xxx DYNAMIC ARRAY OF RECORD -- give me a name
    patient STRING,
    col1 STRING,
    col2 STRING,
    col3 STRING
END RECORD

MAIN
    OPEN FORM f1 FROM "sample"
    DISPLAY FORM f1

    CALL init_data()

    DIALOG --ATTRIBUTES(UNBUFFERED)
        INPUT ARRAY doctores  FROM sr2.* ATTRIBUTES(WITHOUT DEFAULTS,
            INSERT ROW = FALSE, APPEND ROW = FALSE, DELETE ROW = FALSE)
        ON CHANGE doctor
            CALL set_header(DIALOG, arr_curr())
        END INPUT

        INPUT ARRAY arr FROM sr.* ATTRIBUTES(WITHOUT DEFAULTS,
            INSERT ROW = FALSE, DELETE ROW = FALSE, APPEND ROW = FALSE)
        ON ACTION CS DISPLAY "CS" TO sr[scr_line()].col1
        ON ACTION AF DISPLAY "AF" TO sr[scr_line()].col1
        -- next 3 lines can be removed after fixing 
        -- bug 22213: ui: COLOR WHERE ignored when changing a VALUE IN INPUT ARRAY.
        ON CHANGE col1 
        ON CHANGE col2
        ON CHANGE col3
        END INPUT
    ON ACTION ACCEPT
        ACCEPT DIALOG
    BEFORE DIALOG
--        CALL DIALOG.setArrayAttributes("sr", xxx);
        CALL set_header(DIALOG, 1)
        CALL set_header(DIALOG, 2)
        CALL set_header(DIALOG, 3)
    END DIALOG
END MAIN

FUNCTION set_header(d, i)
    DEFINE d ui.Dialog, i INT
    DEFINE f ui.Form
    LET f = d.getForm()
    CALL f.setElementText("formonly.col" || i, doctores[i].date || "\n" || doctores[i].doctor)
END FUNCTION

FUNCTION init_data()
    DEFINE i INT

    FOR i = 1 TO 30
        LET arr[i].patient = "Patient no " || i
        IF i MOD 7 == 0 THEN
            LET arr[i].col1 = "CS"
            LET xxx[i].col1 = "REVERSE RED"
        END IF
        IF i MOD 3 == 0 THEN
            LET arr[i].col2 = "CS"
            LET xxx[i].col2 = "REVERSE BLUE"
        END IF
        IF i MOD 5 == 0 THEN
            LET arr[i].col3 = "CS"
        END IF
    END FOR

    LET doctores[1].DATE = TODAY + 1; LET doctores[1].doctor = "Dr Galmet"
    LET doctores[2].DATE = TODAY + 2; LET doctores[2].doctor = "Dr Poulain"
    LET doctores[3].DATE = TODAY + 3; LET doctores[3].doctor = "Dr Wallas"
END FUNCTION

FUNCTION init_doctores(cb)
    DEFINE cb ui.ComboBox, i INT
    CALL cb.addItem("Dr Galmet", "Dr Galmet");
    CALL cb.addItem("Dr Poulain", "Dr Paulain");
    CALL cb.addItem("Dr Wallas", "Dr Wallas");
END FUNCTION

FUNCTION init_medicaments(cb)
    DEFINE cb ui.ComboBox, i INT
    CALL cb.addItem( "AF", "AF")
    CALL cb.addItem( "CS", "CS")
    CALL cb.addItem( "XB", "XB")
    CALL cb.addItem( "ZG", "ZG")
END FUNCTION
